<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Ajax Axios</title>
    <style>
        @import url('https://fonts.googleapis.com/css2?family=Montserrat:wght@500&display=swap');
        * {
            margin: 0;
            padding: 0;
            box-sizing: border-box;
        }
        a{
            color: black; 
            text-decoration: none;

        }
        a:hover{
            color: white;
        }

        body{
            background: rgb(81,81,93);
            background: radial-gradient(circle, rgba(81,81,93,1) 0%, rgba(21,17,17,1) 100%);
            width: 100vw;
            min-height: 100vh; 
            font-family: 'Montserrat', sans-serif;
            display: flex;
            justify-content: center;
            align-items: center;
            max-width: 1280px;
            padding: 25px;
            margin: 0 auto;
            
        }
        form{
            border: 1px solid #ddd;
            padding: 5px;
            width: 270px;
            background: #efefef;
            align-items: center;
            align-content: center;
            align-self: center;
            text-align: center;
            display: grid;
            
        }
        #buttonsComb{
            padding: 10px;
            
        }
        .inputForm{
            width: 150px;
            margin-top: 10px;
        }
        .buttonsCombEach{
            padding-top: 10px;
            padding-bottom: 10px;
            border-radius: 10px;
            box-shadow: 0px 5px 4px rgba(0, 0, 0, 0.3);
            border-width: 0;
        }
        .buttonsCombEach:hover{
            opacity: 50%;
            cursor: pointer;
        }
        .buttonDelete:hover{
            background-color: red;
            color: white;
        }
        .buttonEdit:hover{
            background-color: rgb(56, 15, 109);
            color: white
        }
        .buttonUpload:hover{
            background-color: rgb(13, 165, 102);
        }

        .card{
            width: 400px; 
            margin:30px;
            border-radius: 18px;
            background: white;
            box-shadow: 5px 5px 15px rgba(0,0,0,0.9);
            text-align: center;
        }
        .card-image img{
            border-radius: 20px;
            background-size: cover;
        }
        .card-text {
            grid-area: text;
            margin: 25px;
        }
        .usrInput{
            padding: 20px;
            width: 400px; 
            margin:30px;
            border-radius: 18px;
            background: white;
            box-shadow: 5px 5px 15px rgba(0,0,0,0.9);
            text-align: center;
        }
        .usrInput label{
            margin: 10px;
        }
        .usrInput input{
            padding: 7px;

        }
        .usrInput textarea{
            padding: 10px;
            font-family: 'Monsterrat',sans-serif;
            
        }
        .errorBox{
            padding: 30px;
            align-items: flex-end;
            justify-content: left;
        }
        
    </style>
</head>
<body>
    <!-- Main App -->
    <div id="app">
        <section id="applevel">
            <div class="errorBox card">
                <h2> Welcome to,</h2>
                <h1>SANBERCODE MEMBER DASHBOARD !</h1>
            </div>

            <form v-on:submit.prevent="addMember()" class="usrInput">
                <label id="nameLabel" for=""> Name </label>
                    <input :disabled='mode == "upload"' type="text" ref="name" v-model="name">
                <label for=""> Address </label>
                    <textarea :disabled='mode == "upload"' name="address" id="address" cols="30" rows="4" v-model="address"></textarea>
                <label for=""> Phone Number </label>
                    <input :disabled='mode == "upload"' type="text" ref="phone" name="phone" id="phone" v-model="no_hp">

                <div v-if="mode == 'submit'">
                    <input class="inputForm buttonsCombEach buttonEdit " type="submit" value="SUBMIT">
                </div>
                <div v-if="mode == 'edit'">
                    <input class="inputForm buttonsCombEach" @click='updateMember(idToUpdate)' type="button" value="UPDATE">
                    <input class="inputForm buttonsCombEach buttonDelete" @click='cancel' type="button" value="CANCEL">
                </div>
                <div v-if="mode == 'upload'" style="margin-top: 5px; align-items: center;">
                    <input class=" inputForm buttonsCombEach" type="file" ref="photo" size="70" name="" id=""> <br>
                    <input class="inputForm buttonsCombEach" @click='uploadMember(idToUpload)' type="button" value="UPLOAD"> <br>
                    <input class="inputForm buttonsCombEach" @click='cancel' type="button" value="CANCEL">
                </div>
            </form>
            <div v-if="errors.length > 0" class="card errorBox">
                <h4> Tolong perbaiki error berikut ini:</h4>
                <ul v-for="(error,index) in errors" :key="index">
                    <p> {{index+1}}.) {{error}} </p>
                </ul>

            </div>
            
            <members-component 
            class="card" v-for="(member, index) in members" :key="index"
            :member='member'
            :domain='domain'
            @edit='edit(member)'
            @delete-member='deleteMember(member.id)'
            @upload='upload(member)'
            ></members-component>
            
        </section>
    </div>
    
    <!-- MembersComponent component template -->
    <template id="membersComp">
        <div >
            <div class="card-image"> <img width=400 height=300 :src="member.photo_profile? (domain+member.photo_profile): 'https://picsum.photos/400/300'" alt="" ></div>
            <div class="card-text">
                <b>Nama : </b> {{member.name}} <br>   
                <b>Alamat : </b> {{member.address}} <br>
                <b>No Telepon : </b> {{member.no_hp}} 
            </div>
            <div class="card-buttons">
                <div id="buttonsComb">
                    <button class="inputForm buttonsCombEach buttonEdit" @click='$emit("edit",member)'>
                        <a href="#nameLabel" >EDIT</a>
                        </button> <br>
                    <button class="inputForm buttonsCombEach buttonDelete" @click='$emit("delete-member",member.id)'>DELETE</button> <br>
                    <button class="inputForm buttonsCombEach buttonUpload" @click='$emit("upload",member)'>
                        <a href="#nameLabel" >UPLOAD PHOTO</a>
                        </button>
                </div>
            </div>
        </div>


    </template>

    <script src="https://cdn.jsdelivr.net/npm/vue@2/dist/vue.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/axios/dist/axios.min.js"></script>
    <script>
        var MembersComponent = {
            template: '#membersComp',
            props:['member','domain']
        }

        var vm = new Vue({
            el:'#app',
            components:{
                'members-component':MembersComponent
            },

            data() {
                return {
                    domain:'http://demo-api-vue.sanbercloud.com',
                    members:[],
                    errors:[],
                    mode:'submit',
                    name:'',
                    address:'',
                    no_hp:'',
                    idToUpdate:null,
                    idToUpload:null
                }
            },

            methods: {
                clear(){
                    this.name='',
                    this.address='',
                    this.no_hp=''
                },
                cancel(){
                    this.clear()
                    this.mode = 'submit'
                },
                validate(){
                    if (this.name.length < 5){
                        alert('Kolom "Name" minimal terdiri dari 5 karakter')
                        this.errors.push('Kolom "Name" minimal terdiri dari 5 karakter')
                    }

                    if (this.address.length > 100){
                        alert('Kolom "Address" maksimal terdiri dari 100 karakter')
                        this.errors.push('Kolom "Address" maksimal terdiri dari 100 karakter')
                    }

                    if (this.no_hp.length < 5){
                        alert('Kolom "Phone Number" minimal terdiri dari 5 digit')
                        this.errors.push('Kolom "Phone Number" minimal terdiri dari 5 digit')
                    }
                },
                getMembers(){
                    this.errors=[]
                    const config = {
                        method : "get",
                        url : "http://demo-api-vue.sanbercloud.com/api/member"
                    }
                    axios(config)
                        .then( (response) => {
                            this.members = response.data.members
                            console.log(response.data);
                        })
                        .catch( (error) => {
                            console.log(error)
                        })
                    },
                addMember(){
                    this.errors=[]
                    this.validate()
                    if (this.errors.length === 0){

                        let formData = new FormData()
                        formData.append('name', this.name)
                        formData.append('address', this.address)
                        formData.append('no_hp', this.no_hp)
                        const config = {
                            method : "post",
                            url : "http://demo-api-vue.sanbercloud.com/api/member",
                            data : formData
                        }
                        axios(config)
                            .then( (response) => {
                                this.clear()
                                this.getMembers()
                                console.log(response.data);
                            })
                            .catch( (error) => {
                                console.log(error)
                            })
                        }
                        
                    },
                edit(member){
                    this.mode='edit'
                    this.name = member.name
                    this.address = member.address
                    this.no_hp = member.no_hp
                    this.idToUpdate = member.id
                },
                deleteMember(id){
                    const config = {
                        method : "post",
                        url : `http://demo-api-vue.sanbercloud.com/api/member/${id}`,
                        params: {
                            _method : 'DELETE'
                        }
                    }
                    if (confirm('Apakah anda yakin akan menghapus member ini?')){
                        
                        axios(config)
                        .then( (response) => {
                            this.getMembers()
                            alert(response.data.message)
                            console.log(response.data);
                        })
                        .catch( (error) => {
                            console.log(error)
                        })
                    }
                    
                },
                updateMember(id){
                    this.errors=[]
                    this.validate()
                    if(this.errors.length === 0 ){
                        let formData = new FormData()
                        formData.append('name', this.name)
                        formData.append('address', this.address)
                        formData.append('no_hp', this.no_hp)
                        const config = {
                            method : "post",
                            url : `http://demo-api-vue.sanbercloud.com/api/member/${id}`,
                            data : formData,
                            params : {
                                _method:'PUT'
                            }
                        }
                        axios(config)
                            .then( (response) => {
                                this.clear()
                                this.cancel()
                                this.getMembers()
                                alert(response.data.message)
                                console.log(response.data);
                            })
                            .catch( (error) => {
                                console.log(error)
                            })
                        
                    }
                },
                upload(member){
                    this.mode = 'upload'
                    this.name = member.name
                    this.address = member.address
                    this.no_hp = member.no_hp
                    this.idToUpload = member.id
                },
                uploadMember(id){
                    console.log(id);
                    let file = this.$refs.photo.files[0]
                    let formPhoto = new FormData()
                    formPhoto.append('photo_profile', file)
                    const config = {
                        method: 'post',
                        url : `http://demo-api-vue.sanbercloud.com/api/member/${id}/upload-photo-profile`,
                        data : formPhoto,
                        
                    }
                    axios(config)
                    .then((response) => {
                        this.clear()
                        this.cancel()
                        alert(response.data.message)
                        this.getMembers()
                        console.log(response.data)})

                    .catch((error) => {console.log(error)})
                },
            },


            created(){
                this.getMembers()
            },
        })
    </script>
</body>
</html>